# LESS QUERY
[![Build Status](https://travis-ci.com/dasx10/less-query.svg?branch=master)](https://travis-ci.com/dasx10/less-query)
----
**Modified approach to responsive layout**
----

@@include('./nav.html')
@@include('./install.md')

## Standard grid system

@@include('./break.html')
@@include('./break.set.html')
@@include('./example/grid-system.html')

<p>Go back to <a href="#navigation">navigation</a></p>
<p>Go to <a href="#overriding-standard-variables">overriding this variables</a></p>

## Mixins

### Core
@@include('./base/grid-system.html')

### Display
@@include('./base/grid.html')
@@include('./base/flex.html')

@@include('./base/align.html')
@@include('./base/justify.html')

### Block model
@@include('./base/height.html')
@@include('./base/width.html')
@@include('./base/margin.html')
@@include('./base/padding.html')
@@include('./base/border.html')
@@include('./base/inline-size.html')
@@include('./base/block-size.html')
@@include('./base/position.html')
@@include('./base/box.html')

### Typography
@@include('./base/text.html')
@@include('./base/font.html')
@@include('./base/word.html')

### Other
@@include('./base/background.html')
@@include('./base/any.html')

Go back to <a href="#mixins">mixins</a> | <a href="#navigation">navigation</a>

## Experimental mixins

@@include('./test/size.html')
@@include('./test/box.html')
@@include('./test/even.html')
@@include('./test/triangle.html')
@@include('./test/shift.html')
@@include('./test/out.html')
@@include('./test/pull.html')
@@include('./test/any.html')
@@include('./test/pxrt.html')


Go back to <a href="#mixins"> mixins</a> | <a href="#experimental-mixins">experimental mixins</a> | <a href="#navigation">navigation</a>

## Functions

@@include('./function/flexible.html')
@@include('./function/converter.html')
@@include('./function/console.html')

Go back to <a href="#functions">functions</a> | <a href="#navigation">navigation</a>

## Examples

@@include('./example/use-grid.html')
@@include('./example/use-multi-line.html')

## Recommendation

@@include('./recomendation.use.html')
@@include('./recomendation.fail.html')
@@include('./recomendation-1.html')
@@include('./recomendation-2.html')
@@include('./recomendation-3.html')
@@include('./recomendation.useQuery.html')

<p>Go back to <a href="#recommendation">recommendation</a> | <a href="#navigation">navigation</a></p>
<p>Go to <a href="#example">example</a></p>

## Overriding standard variables
**These settings are optional, but you can change the default mixin behavior.**

@@include('./assets/install.html')
@@include('./assets/variable.html')
@@include('./assets/dinamic.html')

Go back to <a href="#overriding-standard-variables">Overriding standard variables</a> | <a href="#navigation">navigation</a>

---

@@include('./FAQ.html')

Go back to <a href="#navigation">navigation</a>

***If you find a bug or have suggestions for improving the system, i will be glad to your feedback.***
